/* Boulingas
*/
#include <iostream>
#include <iomanip>
#include <vector>
#include <climits>
#include <fstream>
using namespace std;

struct Lane {
    string number;
    int capacity;
    double hourPrice;
    int rentedByCustomer;
    double moneyEarned;
    int   numberOfRents;
};

typedef vector<Lane> Lanes;

struct Customer {
    string name;
    string PhoneNumber;
    string Age;
    double moneyEarned;
};

typedef vector<Customer> Customers;

void printMeniu     ();
void printLanes     (const Lanes&      lanes);
void printCustomers (const Customers&  customers);
void printLanesBusy (const Lanes&  lanes);
void printLanesFree (const Lanes&  lanes);
void addLane        (      Lanes&      lanes);
void addCustomer    (      Customers&  customers);
void rentLane       (      Lanes&      lanes, Customers& customers);
void laneGotFree    (      Lanes&      lanes);
void mostIncome     (      Lanes&  lanes);
void mostRented     (      Lanes&  lanes);

int main () {
    Lanes      lanes;
    Customers  customers;
    for (;;) {                         /* issiaiskinti ka reiskia toks for'as */
        cout << "\n----------------------------------------\n";
        cout << "(m - rodyti meniu) >  ";
        string command;
        cin >> command;
             if (command == "0") return 0;
        else if (command == "m") printMeniu     ();
        else if (command == "1") printLanes     (lanes);
        else if (command == "2") addLane        (lanes);
        else if (command == "3") rentLane       (lanes, customers);
        else if (command == "4") printCustomers (customers);
        else if (command == "5") addCustomer    (customers);
        else if (command == "6") laneGotFree    (lanes);
        else if (command == "7") printLanesFree (lanes);
        else if (command == "8") printLanesBusy (lanes);
        else if (command == "9") mostIncome     (lanes);
        else if (command == "10")mostRented     (lanes);
        else cout << "neteisinga ivesta komanda" << endl;               
    }
}

void printMeniu () {
    cout << endl
         << "Boulingas" << endl
         << "  1 - spausdinti takelius"           << endl
         << "  2 - prideti takeli"                << endl
         << "  3 - isnuomuoti takeli"             << endl
         << endl
         << "  4 - spausdinti klientus"           << endl
         << "  5 - prideti nauja klienta"         << endl
         << "  6 - atlaisvinti takeli   "         << endl
         << endl
         << "  7 - spausdinti laisvus takelius"   << endl
         << "  8 - spausdinti uzimtus takelius"   << endl
         << endl
         << "  9 - rodyti daugiausiai uzdirbusi"  << endl
         << " 10 - rodyti daugiausiai naudojama"  << endl
         << "  0 - baigti darba"           << endl;
}

void printLanes (const Lanes&    lanes ) {
    cout << "Takeliu kiekis:  " << lanes.size() << endl;
    cout << "Isnuomuoti takeliai: "<< endl;
    cout << "      Talpa  Lt/h     Uzdirbo   Pavadinimas" << endl;

    for (int i = 0; i < lanes.size(); i++ ) {
        int LaneNo = 0;                                 
            cout << (i+1)
            << " ."     << lanes[i].rentedByCustomer
            << "   \t"  << lanes[i].capacity
            << "   "    << lanes[i].hourPrice << "Lt"
            << "   \t(" << lanes[i].moneyEarned << "Lt)"
            <<   "\t"   << lanes[i].number  
            << endl;    
         }
}

void printLanesBusy   (const Lanes&    lanes) {
    int busy = 0;
    for (int i = 0; i < lanes.size(); i++) {
        if (lanes[i].rentedByCustomer != 0) {
            busy += 1;                                  
        }    
    }
    cout << "Uzimtu takeliu kiekis: " << busy << endl;
    for (int i = 0; i < lanes.size(); i++ ) {
        if (lanes[i].rentedByCustomer != 0) {
            cout << (i+1)
            << "   \t"  << lanes[i].capacity
            << "   "    << lanes[i].hourPrice << "Lt"
            << "   \t(" << lanes[i].moneyEarned << "Lt)"
            <<   "\t"   << lanes[i].number  
            << "\t"     << lanes[i].numberOfRents
            << endl;    
        }
    }   
}

void printLanesFree   (const Lanes&    lanes) {
    int free = 0;
    for (int i = 0; i < lanes.size(); i++) {
        if (lanes[i].rentedByCustomer != 0) {
            free += 1;                                  
        }    
    }    
    cout << "Laisva takeliu kiekis: " << free << endl;
    for (int i = 0; i < lanes.size(); i++ ) {
        if (lanes[i].rentedByCustomer == 0) {
            cout << (i+1)
            << " ."     << lanes[i].rentedByCustomer
            << "   \t"  << lanes[i].capacity
            << "   "    << lanes[i].hourPrice << "Lt"
            << "   \t(" << lanes[i].moneyEarned << "Lt)"
            <<   "\t"   << lanes[i].number  
            << endl;    
        }
    }   
}
    
void printCustomers (const Customers&    customers)  {
    cout << "Klientu kiekis:  " << customers.size() << endl;
    for  (int i = 0; i < customers.size(); i++) {
        cout << (i+1)
             << ". (" << customers[i].moneyEarned << "Lt)"
             << "\t"  << customers[i].name
             << " ("  << customers[i].PhoneNumber << ")"
             << " ("  << customers[i].Age << ")"

             << endl;
    }
}

void addLane (Lanes&  lanes) {
    cin.ignore (INT_MAX, '\n' );
    Lane lane;
    cout << "Iveskite takeli:" << endl;
    cout << "Takelio numeris (zodziais)   :  "; getline(cin, lane.number);
    cout << "Takelio talpa(zmoniu maximalus skaicius)   :  "; cin >> lane.capacity;
    cout << "Takelio kaina valandai (Lt)   :  "; cin >> lane.hourPrice;
    lane.rentedByCustomer = 0;
    lane.moneyEarned      = 0;
    lane.numberOfRents     = 0;
    lanes.push_back(lane);
}

void addCustomer (Customers&  customers) {
    cin.ignore (INT_MAX, '\n' );
    Customer customer;
    cout << "Iveskite nauja klienta" << endl;
    cout << "Kliento vardas:    "; getline(cin, customer.name);
    cout << "Telefono numeris:  "; getline(cin, customer.PhoneNumber);
    cout << "Kliento amzius:    "; getline(cin, customer.Age);

    customer.moneyEarned = 0;
    customers.push_back(customer);

}

void rentLane (Lanes&  lanes, Customers&  customers) {
    int LaneNo = 0;
    printLanes (lanes);
    cout << "Iveskite norimo takelio eiles numeri: ";
    cin >> LaneNo;
    if (LaneNo <= 0 || LaneNo > lanes.size()) {
        cout << "KLAIDA, tokio takelio su ivestu eiles numeriu nera";
        return;
    }
    if (lanes[LaneNo-1].rentedByCustomer != 0) {
        cout << "Takelis jau yra isnuomuotas";
        return;
    } 
        
    int CustomerNo = 0; 
    printCustomers (customers);
    cout << "Pasirinkite kliento eiles numeri:  ";
    cin  >> CustomerNo;
    if (CustomerNo <= 0 || CustomerNo > customers.size()) {
        cout << "KLAIDA, tokio kliento, kurio eiles numeri ivedete, nera";
        return;
    }
     int hourCount;
     cout << "Keliom valandom nuomuosite      : ";
     cin  >> hourCount;
     lanes[LaneNo-1].rentedByCustomer     = CustomerNo;
     double moneyEarned = hourCount * lanes[LaneNo-1].hourPrice;
     lanes[LaneNo-1].moneyEarned         += moneyEarned;
     customers[CustomerNo-1].moneyEarned += moneyEarned;
     lanes[LaneNo-1].numberOfRents   += 1;
}

void laneGotFree (Lanes& lanes) {
     int LaneNo = 0;
     printLanes (lanes);
     cout << "Iveskite takelio eil. nr, kuris atsilaisvino:  ";
     cin >> LaneNo;
     if (LaneNo <= 0 || LaneNo > lanes.size()) {
         cout << "KLAIDA, tokio takelio su ivestu eiles numeriu nera";
         return;
     }
     lanes[LaneNo-1].rentedByCustomer = 0;
} 
     
void mostIncome (Lanes& lanes) {
    if (lanes.size() == 0) {
        cout << "Nera takeliu su ivestu numeriu!" << endl;
        return;
    }
    if (lanes.size() == 1) {
        cout << "Siuo metu pas jus yra tik vienas takelis, kuris jums uzdirbo " 
             << lanes[0].moneyEarned << " Lt." << endl;
    }
    double mostIncomeLane;
    if (lanes.size() > 1) {
        mostIncomeLane = lanes[0].moneyEarned;
        for (int i = 1; i <= lanes.size(); i++) {
            if (mostIncomeLane < lanes[i].moneyEarned) {
                mostIncomeLane = lanes[i].moneyEarned;
            }
        }
        cout << "Didziausia pelna atnese";
        for (int i = 0; i < lanes.size(); i++) {
            if (mostIncomeLane == lanes[i].moneyEarned) {
                cout << " " << lanes[i].number;                    
            }    
        }
        cout << " takelis(iai)." << endl;
    }
}

void mostRented (Lanes& lanes) {
    if (lanes.size() == 0) {
        cout << "Nera takeliu su ivestu numeriu!" << endl;
        return;
    }
    if (lanes.size() == 1) {
        cout << "Siuo metu pas jus yra tik vienas takelis, kuris buvo isnuomuotas" 
             << lanes[0].numberOfRents << " kartus(u)." << endl;
    }
    int mostTimesRentedLane;
    if (lanes.size() > 1) {
        mostTimesRentedLane = lanes[0].numberOfRents;
        for (int i = 1; i <= lanes.size(); i++) {
            if (mostTimesRentedLane < lanes[i].numberOfRents) {
                mostTimesRentedLane = lanes[i].numberOfRents;
            }
        }
        cout << "Daugiausiai kartu nuomotas(i) yra";
        for (int i = 0; i < lanes.size(); i++) {
            if (mostTimesRentedLane == lanes[i].numberOfRents) {
                cout << " " << lanes[i].number;
            }    
        }
        cout << " takeliai" << endl;    
    }
}

































